"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_alert_1 = require("react-alert");
const core_1 = require("@material-ui/core");
const contexts_1 = require("../../contexts");
const HypertokenBalanceWidget_style_1 = require("../../widgets/HypertokenBalanceWidget/HypertokenBalanceWidget.style");
const constants_1 = require("../../constants");
const HypertokenBalanceWidget = () => {
    const alert = (0, react_alert_1.useAlert)();
    const { coreProxy } = (0, contexts_1.useStoreContext)();
    const classes = (0, HypertokenBalanceWidget_style_1.useStyles)();
    const { setLoading } = (0, contexts_1.useLayoutContext)();
    const [balance, setBalance] = (0, react_1.useState)();
    (0, react_1.useEffect)(() => {
        setLoading(true);
        coreProxy
            .waitInitialized()
            .map(() => {
            coreProxy
                .getEthereumAccounts()
                .map((accounts) => {
                coreProxy
                    .getHyperTokenBalance(accounts[0])
                    .map((balance) => {
                    setBalance(balance);
                    setLoading(false);
                })
                    .mapErr(handleError);
            })
                .mapErr(handleError);
        })
            .mapErr(handleError);
    }, []);
    const handleError = (err) => {
        setLoading(false);
        alert.error((err === null || err === void 0 ? void 0 : err.message) || "Something went wrong!");
    };
    return (react_1.default.createElement(core_1.Box, { className: classes.wrapper },
        react_1.default.createElement(core_1.Typography, null, balance || "0.0000"),
        react_1.default.createElement("img", { className: classes.logo, src: constants_1.HYPER_TOKEN_LOGO_PURPLE_URL })));
};
exports.default = HypertokenBalanceWidget;
//# sourceMappingURL=HypertokenBalanceWidget.js.map